/***********************************************************************/
/*  													               */
/*      PROJECT NAME :  tstRx                                          */
/*      FILE         :  hardware_setup.c                               */
/*      DESCRIPTION  :  Hardware Initialization                        */
/*      CPU SERIES   :  RX600                                          */
/*      CPU TYPE     :  RX62N                                          */
/*  													               */
/*      This file is generated by KPIT Eclipse.                        */
/*  													               */
/***********************************************************************/                                                                          


#include "iodefine.h"
#include "utype.h"


#ifdef __cplusplus
extern "C" {
#endif
extern void HardwareSetup(void);
#ifdef __cplusplus
}
#endif


uint		SysPCLK;

uint getSysPCLK(void)
{
	return(SysPCLK);
}

void iniHardware(void)
{
	uint	tmp;
	//Xtal:	8-14MHz				*12MHz(USB) 12.5MHz(Ether)
	//ICLK(System Clock)		Xtal*(8/4/2/1) <= 100MHz
	//PCLK(Peripheral Clock)	8-50MHz
	//BCLK(Bus Clock)			8-100MHz (BCLK <= ICLK)
	//SDCLK(SDRAM clock)		8-50MHz
	//UCLK(USB clock)			48MHz=4*ICLK
	//SUBCLK(RTC clock)			32.768KHz RXT Xtal
	//IWTCLK(OnChip OSC clock)	125KHz
	tmp =	(0<<24) |	//ICLK:(0/1/2/3)=(*8/*4/*2/*1) (96MHz)
			(1<<23) |	//PSTOP1: output BCLK(0/1)=(enabled/disabled)
			(1<<22) |	//PSTOP2: output SDCLK(0/1)=(enabled/disabled)
			(2<<16) |	//BCLK (<=ICLK) *2(24MHz)(0/1/2/3)=(*8/*4/*2/*1)
			(1<<8);		//PCLK: *4(48MHz)(0/1/2/3)=(*8/*4/*2/*1)
	SYSTEM.SCKCR.LONG = tmp;
	while(SYSTEM.SCKCR.LONG != tmp);
	
	SYSTEM.SUBOSCCR.BIT.SUBSTOP = 1;	//sub clk(32.768KHz) (0/1)=(disable/enable)

	SysPCLK = 48*1000000;
/*
  SCI.SMR.BYTE = 0;
  SCI.SMR.BIT.CA   = 1;
  SCI.SMR.BIT.CHR  = 1;
  SCI.SMR.BIT.OE   = 1;
  SCI.SMR.BIT.STOP = 1;
  SCI.SMR.BIT.MP   = 1;
  SCI.SMR.BIT.CKS  = 3;
  SCI.BRR = 0;
  SCI.SCR.BYTE = 0;
  SCI.SCR.BIT.TIE  = 1;
  SCI.SCR.BIT.RIE  = 1;
  SCI.SCR.BIT.TE   = 1;
  SCI.SCR.BIT.RE   = 1;
  SCI.SCR.BIT.MPIE = 1;
  SCI.SCR.BIT.TEIE = 1;
  SCI.SCR.BIT.CKE  = 3;
  SCI.TDR = 0;
  SCI.SSR.BYTE = 0;
  SCI.SSR.BIT.TDRE = 1;
  SCI.SSR.BIT.RDRF = 1;
  SCI.SSR.BIT.ORER = 1;
  SCI.SSR.BIT.FER  = 1;
  SCI.SSR.BIT.PER  = 1;
  SCI.SSR.BIT.TEND = 1;
  SCI.SSR.BIT.MPB  = 1;
  SCI.SSR.BIT.MPBT = 1;
  SCI.RDR = 0;

*/
}
